Attribute VB_Name = "misc"
Declare Function StartDoc Lib "gdi32" Alias "StartDocA" (ByVal hdc As Long, lpdi As DOCINFO) As Long
Declare Function EndDoc Lib "gdi32" (ByVal hdc As Long) As Long
Declare Function PrintDlg Lib "comdlg32.dll" Alias "PrintDlgA" (pPrintdlg As strPRINTDLG) As Long
Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Declare Function CreatePen Lib "gdi32" (ByVal nPenStyle As Long, ByVal nWidth As Long, ByVal crColor As Long) As Long
Declare Function MoveToEx Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal lpPoint As Long) As Long
Declare Function LineTo Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long) As Long
Declare Function GetDeviceCaps Lib "gdi32" (ByVal hdc As Long, ByVal nIndex As Long) As Long
Declare Function StartPage Lib "gdi32" (ByVal hdc As Long) As Long
Declare Function EndPage Lib "gdi32" (ByVal hdc As Long) As Long
Declare Function SetBkMode Lib "gdi32" (ByVal hdc As Long, ByVal nBkMode As Long) As Long
Declare Function CreateFont Lib "gdi32" Alias "CreateFontA" (ByVal H As Long, ByVal W As Long, ByVal E As Long, ByVal O As Long, ByVal W As Long, ByVal i As Long, ByVal u As Long, ByVal s As Long, ByVal c As Long, ByVal op As Long, ByVal CP As Long, ByVal Q As Long, ByVal PAF As Long, ByVal f As String) As Long
Declare Function SetTextColor Lib "gdi32" (ByVal hdc As Long, ByVal crColor As Long) As Long
Declare Function DrawText Lib "user32" Alias "DrawTextA" (ByVal hdc As Long, ByVal lpStr As String, ByVal nCount As Long, lpRect As RECT, ByVal wFormat As Long) As Long
Declare Function Rectangle Lib "gdi32" (ByVal hdc As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long

Declare Function GetSaveFileName Lib "comdlg32.dll" Alias "GetSaveFileNameA" (pOpenfilename As OPENFILENAME) As Long
Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long
Type OPENFILENAME
        lStructSize As Long
        hwndOwner As Long
        hInstance As Long
        lpstrFilter As String
        lpstrCustomFilter As String
        nMaxCustFilter As Long
        nFilterIndex As Long
        lpstrFile As String
        nMaxFile As Long
        lpstrFileTitle As String
        nMaxFileTitle As Long
        lpstrInitialDir As String
        lpstrTitle As String
        flags As Long
        nFileOffset As Integer
        nFileExtension As Integer
        lpstrDefExt As String
        lCustData As Long
        lpfnHook As Long
        lpTemplateName As String
End Type

'xp\
Type LabelData
  X1 As Long 'RECT
  Y1 As Long
  X2 As Long
  Y2 As Long
  FHeight As Long
  FWidth As Long
  FAlignMiddle As Long '0- 1-S 2-E
  FontName As String
  TextData As String
End Type

Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type

Public Const PHYSICALHEIGHT = 111
Public Const PHYSICALWIDTH = 110
Public Const PHYSICALOFFSETX = 112
Public Const PHYSICALOFFSETY = 113
Public Const DT_CALCRECT = &H400

Type DOCINFO
        cbSize As Long
        lpszDocName As String
        lpszOutput As String
End Type

Type strPRINTDLG
        lStructSize As Long
        hwndOwner As Long
        hDevMode As Long
        hDevNames As Long
        hdc As Long
        flags As Long
        nFromPage As Integer
        nToPage As Integer
        nMinPage As Integer
        nMaxPage As Integer
        nCopies As Integer
        hInstance As Long
        lCustData As Long
        lpfnPrintHook As Long
        lpfnSetupHook As Long
        lpPrintTemplateName As Long
        lpSetupTemplateName As Long
        hPrintTemplate As Long
        hSetupTemplate As Long
End Type

Function RemoveExtension(FileName As String) As String
't@Cgq菜
Dim i&

For a = Len(FileName) To 1 Step -1
  If Mid(FileName, a, 1) = "." Then '납u . vTĂ
    RemoveExtension = Left(FileName, a - 1)
    Exit Function
  End If
Next

'ꍇ
RemoveExtension = ""
End Function

Function CountString(target As String, FromStr As String)
'񐔃JEg
Dim i&
Dim LT&, LF&, NumTar&
LT = Len(target)
LF = Len(FromStr)

For i = 1 To LF + 1 - LT
  If Mid(FromStr, i, LT) = target Then NumTar = NumTar + 1
Next

CountString = NumTar

End Function


Function ReplaceString(ByVal target As String, ByVal FromString As String, ByVal ToString As String) As String
Dim a$, b$, c$, d$, i&, j&
'u
a = target
b = FromString
c = ToString
j = Len(FromString)

i = InStr(a, b)
Do While i <> 0
  'u
  a = Left(a, i - 1) + c + Right(a, Len(a) - i - j + 1)
  i = InStr(a, b)
Loop

ReplaceString = a

End Function

Function SplitString(ByVal target As String, ByVal Splitter As String) As Variant
'w肵ŕ
'Splitter͂PAKvȂReplaceString𗘗p
Dim st$()
Dim i&, j&, k&, s$, l&, l2&

i = 1
l = Len(target)
l2 = Len(Splitter)
For j = 1 To l - l2 + 1
  If Mid(target, j, l2) = Splitter Then
    s = Mid(target, i, j - i)
    ReDim Preserve st(k) As String
    st(k) = s
    i = j + l2
    k = k + 1
  End If
Next

s = Mid(target, i, j - i + 1)
ReDim Preserve st(k) As String
st(k) = s

SplitString = st
End Function

Function GetOpenName() As String
'R_CAOɂ摜t@C擾
Dim OFN As OPENFILENAME
Dim t As String

With OFN
  .lStructSize = LenB(OFN)
  .hwndOwner = 0
  .hInstance = App.hInstance
  .lpstrFilter = "g[ig`t@C(*.dat)" + vbNullChar + "*.dat"
  .nFilterIndex = 1
  .lpstrFile = String(512, vbNullChar)
  .nMaxFile = 512
  .lpstrTitle = "g[ig`t@C"
  .flags = &H281004
  .lpstrDefExt = "*.dat"
  
  Call GetOpenFileName(OFN)
  
  t = .lpstrFile
  ' vbNullChar & vbNullChar̕܂łŐ؂oB
  t = Left(t, InStr(t, vbNullChar & vbNullChar) - 1)
  GetOpenName = t

End With
End Function

